%macro OptimalDesign1;
    proc iml;
        * Compute the optimal design;
        start Doptimal(n) global(design,grid,weight,result,k,
            nder,newxder,dist,ninit);
        nobs=nrow(design);        
        wp=&const1/(k*&const2+ninit);        
        i=result[<:>];
        xpoint=grid[i,];
        merge=0;
        weight=weight*(1-wp);    
        do j=1 to nobs until (merge=1);
            if sqrt(ssq(design[j,]-xpoint))<=&cmerge*dist then do;
                weight[j]=weight[j]+wp;
                design[j,]=xpoint;
                nder[j,]=newxder[i,];
                merge=1;
            end;
        end;
        if (merge=0) then do;
            pnew=wp;
            weight=weight//pnew;
            design=design//xpoint;
            nder=nder//newxder[i,];
        end;
        nobs1=nrow(design);    
        m=j(n,n,0);
        %infod(nobs1,nder,result,2);    
        i=result[>:<];
        xdelet=design[i,]; 
        if weight[i]< wp then do;
            a=weight[i]/(1-weight[i]);
            weight=weight*(1+a);
            if i=1 then do;
                weight=weight[i+1:nobs1,];
                design=design[i+1:nobs1,];
                nder=nder[i+1:nobs1,];
            end;
            else do;
            if i=nobs1 then do;
                weight=weight[1:i-1,];
                design=design[1:i-1,];
                nder=nder[1:i-1,];
            end;
            else do;
                weight=weight[1:i-1,]//weight[i+1:nobs1,];
                design=design[1:i-1,]//design[i+1:nobs1,];
                nder=nder[1:i-1,]//nder[i+1:nobs1,];
            end;
        end;
        end;
        else do;
            weight=weight*(1+wp);
            weight[i]=weight[i]-wp;
        end;
        nobs1=nrow(design);
        m=j(n,n,0);
        %infod(nobs1,newxder,result,2);
        criter=log(det(invm));
        return(criter);
        finish DOptimal;
    design=t(&points);
    weight=t(&weights);
    grid=t(&grid);         
    * Number of points in the grid; 
    gridn=nrow(grid);
    dist=(grid[gridn]-grid[1])/(gridn-1);
    * Number of parameters;
    parameter=&parameter;
    paran=ncol(parameter); 
    * Information matrix;
    m=j(paran,paran,0);
    * Number of points in the initial design; 
    ninit=nrow(design);    
    nobs=nrow(grid);
    %infod(ninit,newxder,sensi1,1);            
    * Initial design points and weights;
    initial=j(ninit,2,0);   
    initial[,1]=design;
    initial[,2]=weight;
    create initial from initial[colname={x,p}]; append from initial; close initial;    
    * Variance-covariance matrix, initial design;
    d=invm; create dinitial from d; append from d; close dinitial;
    * Determinant of the variance-covariance matrix, initial design;
    ddet=j(1,2,0);    
    ddet[1]=det(d);
    * Sensitivity function, initial design;
    sensitivity=j(gridn,3,0);
    sensitivity[,1]=grid;
    sensitivity[,2]=sensi1;    
    num=&maximit;
    result=sensi1;
    do k=1 to num until(stop=1);
        stop=0;
        s=k;    
        criter=DOptimal(paran);
        if k=1 then critout=criter;
        if k>1 then do;
            critout=critout//criter;
            out=abs((critout[k]-critout[k-1])/critout[k-1]);
            if out[1]<&convc then do; 
                s=k; de=exp(criter); stop=1;
            end;
        end;
    end;
    m=j(paran,paran,0);
    * Number of points in the final design; 
    nfinal=nrow(design);
    %infod(nfinal,newxder,sensi2,2);
    * Variance-covariance matrix, optimal design;
    d=invm; create doptimal from d; append from d; close doptimal;
    * Determinant of the variance-covariance matrix, optimal design;
    ddet[2]=det(d); create ddet from ddet[colname={initial,optimal}];
    append from ddet; close ddet;
    * Sensitivity function, optimal design;
    sensitivity[,3]=sensi2;    
    create sensit from sensitivity[colname={point,initial,optimal}];
    append from sensitivity; close sensit;       
    * Optimal design points and weights;
    optimal=j(nfinal,2,0);   
    optimal[,1]=design;
    optimal[,2]=weight;
    create optimal from optimal[colname={x,p}]; append from optimal; close optimal;    
    quit;    
%mend OptimalDesign1;