%macro doptimal(n);
    d=invm; 
    result=j(nobs,1,0);
    do v=1 to nobs;
    pos=loc(allm[,1]=v); 
    test=allm[t(pos),2:&paran+1]; 
    result[v,]=trace(test*D);
    end; 
    wp=&const1/(k*&const2+ninit); 
    i=result[<:>];
    xpoint=grid[i,];       
    merge=0;
    weights=weights*(1-wp); 
    nobs1=nrow(points);     
    do j=1 to nobs1 until (merge=1);
    if sqrt(ssq(points[j,]-xpoint))<=&cmerge*dist then do;
    M=(M-weights[j]/(1-wp)*
    designm[t(loc(designm[,1]=j)),2:&paran+1])*(1-wp)
    +(weights[j]+wp)*allm[t(loc(allm[,1]=i)), 2:&paran+1];
    weights[j]=weights[j]+wp;
    points[j,]=xpoint;
    designm[t(loc(designm[,1]=j)),2:&paran+1]
    =allm[t(loc(allm[,1]=i)), 2:&paran+1];
    merge=1;
    end;
    end; 
    if (merge=0) then do;
    pnew=wp;
    weights=weights//pnew;
    points=points//xpoint; 
    addm=j(&paran,1,nobs1+1)||allm[t(loc(allm[,1]=i)),2:&paran+1]; 
    designm=designm//addm;
    M=M*(1-wp)+pnew*allm[t(loc(allm[,1]=i)),2:&paran+1]; 
    end;
    invm=inv(M); 
    result=j(nobs1,1,0);
    do v= 1 to nobs1;
    pos=loc(designm[,1]=v); 
    test=designm[t(pos),2:&paran+1]; 
    result[v,]=trace(test*D);
    end; 
    nobs1=nrow(points);
    i=result[>:<]; 
    xdelet=points[i,];           
    if weights[i]< wp then do; 
    a=weights[i]/(1-weights[i]);
    m=(m-weights[i]*designm[t(loc(designm[,1]=i)),2:&paran+1])*(1+a); 
    weights=weights*(1+a);
    if i=1 then do;
    weights=weights[i+1:nobs1,];
    points=points[i+1:nobs1,];
    designm=designm[t(loc(designm[,1]>i)),]; 
    designm[t(loc(designm[,1]>=i)),1]=designm[t(loc(designm[,1]>=i)),1]-1;
    end;
    else do;
    if i=nobs1 then do;
    weights=weights[1:i-1,];
    points=points[1:i-1];
    designm=designm[t(loc(designm[,1]<i)),]; 
    end;
    else do;
    weights=weights[1:i-1,]//weights[i+1:nobs1,];
    points=points[1:i-1,]//points[i+1:nobs1,];
    designm=designm[t(loc(designm[,1]<i)),]//designm[t(loc(designm[,1]>i)),]; 
    designm[t(loc(designm[,1]>=i)),1]=designm[t(loc(designm[,1]>=i)),1]-1;
    end;
    end;
    end;  
    else do;
    m=m*(1+wp)-wp*designm[t(loc(designm[,1]=i)),2:&paran+1];
    weights=weights*(1+wp);
    weights[i]=weights[i]-wp;
    end;  
    invm=inv(m);
    criter=log(det(invm)); 
%mend doptimal;
%macro OptimalDesign3;
    proc iml;
        %DesignParameters;
        ninit=nrow(points);
        * Grid;        
        create grid from grid[colname={x,z}]; append from grid; close grid;                    
        dist=(((grid[<>,1]-grid[><,1])/(gridn-1))**2+((grid[<>,2]-grid[><,2])/(gridn-1))**2)**0.5;                       
        %infoele(points,sele,sele77,sele78,sele79,sele88,sele89,sele99); 
        %indinfo(sele,ninit,designm); 
        %info(weights,sele,m);                
        * Initial design points and weights;
        initial=j(ninit,3,0);   
        initial[,1]=points[,1];
        initial[,2]=points[,2];
        initial[,3]=weights;
        create initial from initial[colname={x,z,p}]; append from initial; close initial;    
        * Variance-covariance matrix, initial design;
        invm=inv(m); d=invm; ided=det(d);        
        create dinitial from d; append from d; close dinitial;
        * Determinant of the variance-covariance matrix, initial design;
        ddet=j(1,2,0);    
        ddet[1]=ided;
        %infoele(grid,ele,ele77,ele78,ele79,ele88,ele89,ele99); 
        nobs=nrow(grid);
        %indinfo(ele,nobs,allm); 
        result=j(nobs,1,0);
        do v=1 to nobs;
            pos=loc(allm[,1]=v); 
            test=allm[t(pos),2:&paran+1]; 
            result[v,]=trace(test*d);
        end;        
        num=&maximit;
        do k=1 to num until(stop=1);
            stop=0;
            s=k;
            %doptimal(&paran); 
            if k=1 then critout=criter;
            if k>1 then do;
                critout=critout//criter;
                out=abs((critout[k]-critout[k-1])/critout[k-1]); 
                if out[1]<&convc then do; 
                    s=k;
                    de=exp(criter); 
                    stop=1;
                end;
            end;
        end;
        * Variance-covariance matrix, optimal design;
        invm=inv(m); d=invm; create doptimal from d; append from d; close doptimal;
        * Determinant of the variance-covariance matrix, optimal design;
        ddet[2]=det(d); create ddet from ddet[colname={initial,optimal}];
        append from ddet; close ddet;
        result=j(nobs,1,0);
        do v=1 to nobs;
            pos=loc(allm[,1]=v); 
            test=allm[t(pos),2:&paran+1]; 
            result[v,]=trace(test*d);
        end; 
        * Number of points in the final design; 
        nfinal=nrow(points);
        * Optimal design points and weights;
        optimal=j(nfinal,3,0);   
        optimal[,1]=points[,1];
        optimal[,2]=points[,2];
        optimal[,3]=weights;
        create optimal from optimal[colname={x,z,p}]; append from optimal; close optimal; 
        quit;
%mend OptimalDesign3;