%macro doptimal(n);
    %infod(result,2); 
    wp=&const1/(k*&const2+ninit); 
    i=result[<:>]; 
    xpoint=grid[i,];      
    merge=0;
    weight=weight*(1-wp); 
    nobs1=nrow(design);     
    do j=1 to nobs1 until (merge=1);
    if sqrt(ssq(design[j,]-xpoint))<=&cmerge*dist then do;
    M=(M-weight[j]/(1-wp)*
    designm[t(loc(designm[,1]=j)),2:&paran+1])*(1-wp)
    +(weight[j]+wp)*allm[t(loc(allm[,1]=i)), 2:&paran+1];
    weight[j]=weight[j]+wp;
    design[j,]=xpoint;
    designm[t(loc(designm[,1]=j)),2:&paran+1]
    =allm[t(loc(allm[,1]=i)), 2:&paran+1];
    merge=1;
    end;
    end; 
    if (merge=0) then do;
    pnew=wp;
    weight=weight//pnew;
    design=design//xpoint; 
    addm=j(&paran,1,nobs1+1)||allm[t(loc(allm[,1]=i)),2:&paran+1]; 
    designm=designm//addm;
    M=M*(1-wp)+pnew*allm[t(loc(allm[,1]=i)),2:&paran+1]; 
    end;
    invm=inv(M); 
    nobs1=nrow(design);     
    resultd=j(nobs1,1,0);
    do v=1 to nobs1;
    pos=loc(designm[,1]=v); 
    test=designm[t(pos),2:&paran+1]; 
    resultd[v,]=trace(test*invm); 
    end; 
    i=resultd[>:<]; 
    xdelet=design[i,];           
    if weight[i]< wp then do; 
    a=weight[i]/(1-weight[i]);
    m=(m-weight[i]*designm[t(loc(designm[,1]=i)),2:&paran+1])
    *(1+a); 
    weight=weight*(1+a);
    if i=1 then do;
    weight=weight[i+1:nobs1,];
    design=design[i+1:nobs1,];
    designm=designm[t(loc(designm[,1]>i)),]; 
    designm[t(loc(designm[,1]>=i)),1]=designm[t(loc(designm[,1]>=i)),1]-1;
    end;
    else do;
    if i=nobs1 then do;
    weight=weight[1:i-1,];
    design=design[1:i-1,];
    designm=designm[t(loc(designm[,1]<i)),]; 
    end;
    else do;
    weight=weight[1:i-1,]//weight[i+1:nobs1,];
    design=design[1:i-1,]//design[i+1:nobs1,];
    designm=designm[t(loc(designm[,1]<i)),]//designm[t(loc(designm[,1]>i)),]; 
    designm[t(loc(designm[,1]>=i)),1]=designm[t(loc(designm[,1]>=i)),1]-1;
    end;
    end;
    end;  
    else do;
    m=m*(1+wp)-wp*designm[t(loc(designm[,1]=i)),2:&paran+1];
    weight=weight*(1+wp);
    weight[i]=weight[i]-wp;
    end;  
    ndesign=nrow(design);
    critm=inv(m);
    criter=log(det(critm)); 
%mend doptimal;
%macro OptimalDesign4;
    proc iml;
        design=t(&points);
        weight=t(&weights);
        grid=t(&grid); 
        parameter=&parameter;
        m=j(&paran,&paran,0);
        ninit=nrow(design);
        nobs=nrow(grid);
        dist=0.0025;
        %infod(result,1); 
        * Initial design points and weights;
        initial=j(ninit,2,0);   
        initial[,1]=design;
        initial[,2]=weight;
        create initial from initial[colname={x,p}]; append from initial; close initial;    
        * Variance-covariance matrix, initial design;
        invm=inv(m); d=invm; ided=det(d);        
        create dinitial from d; append from d; close dinitial;
        * Determinant of the variance-covariance matrix, initial design;
        ddet=j(1,2,0);    
        ddet[1]=ided;
        * Sensitivity function, initial design;
        sensitivity=j(nobs,3,0);
        sensitivity[,1]=grid;
        sensitivity[,2]=result; 
        num=&maximit;
        do k=1 to num until(stop=1);
        stop=0;
            s=k;
            %doptimal(&paran); 
            if k=1 then critout=criter;
            if k>1 then do;
                critout=critout//criter;
                out=abs((critout[k]-critout[k-1])/critout[k-1]); 
                if out[1]<&convc then do; 
                    s=k;
                    de=exp(criter); 
                    stop=1;
                end;
            end;
        end;
        * Variance-covariance matrix, optimal design;
        invm=inv(m); d=invm; create doptimal from d; append from d; close doptimal;
        * Determinant of the variance-covariance matrix, optimal design;
        ddet[2]=det(d); create ddet from ddet[colname={initial,optimal}];
        append from ddet; close ddet;
        %infod(result,2);
        * Number of points in the final design; 
        nfinal=nrow(design);
        * Sensitivity function, optimal design;
        sensitivity[,3]=result;    
        create sensit from sensitivity[colname={point,initial,optimal}];
        append from sensitivity; close sensit;       
        * Optimal design points and weights;
        optimal=j(nfinal,2,0);   
        optimal[,1]=design;
        optimal[,2]=weight;
        create optimal from optimal[colname={x,p}]; append from optimal; close optimal; 
        quit;
%mend OptimalDesign4;